//============================================================================
//  aPCI-8131 for PCI Linux Device Driver
//  apci8131.h
//  Author  Shoichiro Ito(ADTEK SYSTEM SCIENCE Co.,Ltd.)
//  Date    2001/02/28
//  Rev.    1.0.0
//============================================================================


#ifndef __INC_APCI8131_H__
#define __INC_APCI8131_H__


//-----------------------------------------------------------
//  Macros to help debugging
//-----------------------------------------------------------

#undef PDEBUG		  /* undef it, just in case */
#ifdef APCI8131_DEBUG
#	ifdef __KERNEL__
		/* This one if debugging is on, and kernel space */
#		define PDEBUG(fmt, args...) printk(KERN_DEBUG "[APCI8131]: " fmt, ## args)
#	else
		/* This one for user space */
#		define PDEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
#	endif
#else
#	define PDEBUG(fmt, args...) /* not debugging: nothing */
#endif

#undef PDEBUGG
#define PDEBUGG(fmt, args...) /* nothing: it's a placeholder */


//-----------------------------------------------------------
//  Miscellaneous
//-----------------------------------------------------------

#define APCI8131_MAX_DEVICES	16		// ǥХ
#define APCI8131_MAX_PORTS	4		// IO ݡȿ
#define APCI8131_MAX_IRQS	4		// װ


//-----------------------------------------------------------
//  Device I/O Defined
//-----------------------------------------------------------

// Input/Output Ports
#define APCI8131_IO_PORT_1	0x00
#define APCI8131_IO_PORT_2	0x01
#define APCI8131_IO_PORT_3	0x02
#define APCI8131_IO_PORT_4	0x03

// Input Ports
#define APCI8131_BSN_PORT	0x0F		// BSN


// Offset 0x0F	    APCI8131_BSN_PORT(I)
#define APCI8131_GET_BSN(n) ((n >> 4) & 0x0F)	// BSN ޥ


//-----------------------------------------------------------
//  Device I/O Control Codes
//-----------------------------------------------------------

#define APCI8131_IOC_MAGIC  'Z'

#define APCI8131_IN_PORT    _IOWR(APCI8131_IOC_MAGIC, 0, apci8131_io)
#define APCI8131_OUT_PORT   _IOW (APCI8131_IOC_MAGIC, 1, apci8131_io)
#define APCI8131_GET_IFR    _IOR (APCI8131_IOC_MAGIC, 2, unsigned char)
#define APCI8131_GET_ICR    _IOR (APCI8131_IOC_MAGIC, 3, unsigned short)
#define APCI8131_SET_ICR    _IOW (APCI8131_IOC_MAGIC, 4, unsigned short)

#define APCI8131_IOC_MAXNR  4


// TODO:  桼ץꥱȤ̿Ѥǡ¤򤳤˵Ҥޤ

typedef struct _apci8131_io
{
	unsigned int  port;
	unsigned char value;
} apci8131_io, *papci8131_io;


#endif // __INC_APCI8131_H__
